$(function () {
    $("#jqGrid").jqGrid({
        url: '../goodsissue/list',
        datatype: "json",
        colModel: [
            {label: 'id', name: 'id', index: 'id', key: true, hidden: true},
            {label: '商户编号', name: 'merchSn', index: 'merchSn', width: 80},
            {label: '门店名称', name: 'storeName', index: 'storeName', width: 80},
            {label: '问题', name: 'question', index: 'question', width: 80},
            {label: '回答', name: 'answer', index: 'answer', width: 250}],
        viewrecords: true,
        height: 550,
        rowNum: 10,
        rowList: [10, 30, 50],
        rownumbers: true,
        rownumWidth: 25,
        autowidth: true,
        multiselect: true,
        pager: "#jqGridPager",
        jsonReader: {
            root: "page.list",
            page: "page.currPage",
            total: "page.totalPage",
            records: "page.totalCount"
        },
        prmNames: {
            page: "page",
            rows: "limit",
            order: "order"
        },
        gridComplete: function () {
            $("#jqGrid").closest(".ui-jqgrid-bdiv").css({"overflow-x": "hidden"});
        }
    });
});

var vm = new Vue({
    el: '#rrapp',
    data: {
        showList: true,
        title: null,
        goodsIssue: {},
        ruleValidate: {
            question: [
                {required: true, message: '问题不能为空', trigger: 'blur'}
            ],
            answer: [
                {required: true, message: '回答不能为空', trigger: 'blur'}
            ]
        },
        q: {
            question: ''
        },
        storeList: [],
        merchList: []
    },
    methods: {
        query: function () {
            vm.reload();
        },
        add: function () {
            vm.showList = false;
            vm.title = "新增";
            vm.goodsIssue = {};
            vm.storeList = [];
            vm.merchList = [];
            vm.getMerchList();
        },
        update: function (event) {
            var id = getSelectedRow();
            if (id == null) {
                return;
            }
            vm.showList = false;
            vm.title = "修改";

            vm.getInfo(id);
            vm.getMerchList();
            var rowData = $("#jqGrid").jqGrid('getRowData', id);
            vm.getStoresByValue(rowData.merchSn);
        },
        getStoresByValue: function (value) {
            $.get("../store/getStoresByMerch?merchSn=" + value, function (r) {
                vm.storeList = r.list;
            });
        },
        getStoresByMerch: function (opt) {
            var value = opt.value;
            $.get("../store/getStoresByMerch?merchSn=" + value, function (r) {
                vm.storeList = r.list;
            });
        },
        getMerchList: function() {
            $.get("../merch/queryAll", function (r) {
                vm.merchList = r.list;
            });
        },
        saveOrUpdate: function (event) {
            var url = vm.goodsIssue.id == null ? "../goodsissue/save" : "../goodsissue/update";
            $.ajax({
                type: "POST",
                url: url,
                contentType: "application/json",
                data: JSON.stringify(vm.goodsIssue),
                success: function (r) {
                    if (r.code === 0) {
                        alert('操作成功', function (index) {
                            vm.reload();
                        });
                    } else {
                        alert(r.msg);
                    }
                }
            });
        },
        del: function (event) {
            var ids = getSelectedRows();
            if (ids == null) {
                return;
            }

            confirm('确定要删除选中的记录？', function () {
                $.ajax({
                    type: "POST",
                    url: "../goodsissue/delete",
                    contentType: "application/json",
                    data: JSON.stringify(ids),
                    success: function (r) {
                        if (r.code == 0) {
                            alert('操作成功', function (index) {
                                $("#jqGrid").trigger("reloadGrid");
                            });
                        } else {
                            alert(r.msg);
                        }
                    }
                });
            });
        },
        getInfo: function (id) {
            $.get("../goodsissue/info/" + id, function (r) {
                vm.goodsIssue = r.goodsIssue;
            });
        },
        reload: function (event) {
            vm.showList = true;
            var page = $("#jqGrid").jqGrid('getGridParam', 'page');
            $("#jqGrid").jqGrid('setGridParam', {
                postData: {'question': vm.q.question, 'goodsName': vm.q.goodsName},
                page: page
            }).trigger("reloadGrid");
            vm.handleReset('formValidate');
        },
        handleSubmit: function (name) {
            handleSubmitValidate(this, name, function () {
                vm.saveOrUpdate()
            });
        },
        handleReset: function (name) {
            handleResetForm(this, name);
        }
    }
});